/*
 * Copyright (c) 2010 Mysema Ltd.
 * All rights reserved.
 * 
 */
package com.mysema.commons.lang;


/**
 * Typed pair of values
 * 
 * @author tiwe
 */
public class Pair<F,S>{
       
    private final F first;

    private final S second;
    
    public Pair(F first, S second){
        this.first = Assert.notNull(first,"first");
        this.second = Assert.notNull(second,"second");
    }
    
    public static <F,S> Pair<F,S> of(F f, S s){
        return new Pair<F,S>(f, s);
    }
    
    @Override
    @SuppressWarnings("unchecked")
    public boolean equals(Object o){
        if (o == this){
            return true;
        }else if (o instanceof Pair){
            return ((Pair)o).first.equals(first) 
                && ((Pair)o).second.equals(second);    
        }else{
            return false;
        }
        
    }
    
    public F getFirst() {
        return first;
    }

    public S getSecond() {
        return second;
    }

    @Override
    public int hashCode(){
        return 31 * first.hashCode() + second.hashCode();
    }
    
}
